//
//  GFileRunner file
//  By Kyle Davis
//
//  This controls cursor related functions.
//

#include "gfilerunner-cursor.h"

void set_cursor_busy(GtkWidget *window){
        GdkCursor *cursor;
// TODO:  Don't do for desktop!!
//        if(is_a_desktop_panel(window)) return;

        cursor=gdk_cursor_new(GDK_WATCH);
        gdk_window_set_cursor(GTK_WIDGET(window)->window, cursor);
        gdk_cursor_destroy(cursor);
        gdk_flush();

}

void set_cursor_normal(GtkWidget *window){
// TODO:  Don't do for desktop!!
//        if(is_a_desktop_panel(window)) return;
        gdk_window_set_cursor(GTK_WIDGET(window)->window, NULL);
        gdk_flush();
}

