//TODO:!!!  Try to see if you can get a GDK Drawable or SOMETHING and make this not _SO_ SLOW
//This is our "lasso" (multiple file selection w/ mouse)
//

#include "gfilerunner-lasso.h"

gfilerunner_lasso* gfilerunner_lasso_new(GnomeCanvasGroup*canvas_group,gfloat x1,gfloat y1,gfloat x2,gfloat y2,
						long fill_rgba,GdkBitmap*fill_stipple,long outline_rgba){
	gfilerunner_lasso*gfrlasso=g_new(gfilerunner_lasso,1);
	g_assert(gfrlasso!=NULL);
	gfrlasso->x1=0;
	gfrlasso->y1=0;
	gfrlasso->x2=0;
	gfrlasso->y2=0;
//	gfrlasso->lasso=NULL;
/*	gfrlasso->lasso=gnome_canvas_item_new(GNOME_CANVAS_GROUP(canvas_group),gnome_canvas_rect_get_type(),
					"x1",0.0, "y1",0.0, "x2",0.0, "y2",0.0,
					"fill_color_rgba",fill_rgba,
					"fill_stipple",fill_stipple,
					"outline_color_rgba",outline_rgba,
					"width_pixels",0.0,
					NULL);
*/
	gfrlasso->l=NULL;
	gfrlasso->t=NULL;
	gfrlasso->r=NULL;
	gfrlasso->b=NULL;

	//TODO:  "line_style", GdkLineStyle,    //this would be nice....
	gfrlasso->lpts=gnome_canvas_points_new(2);
	gnome_canvas_points_ref(gfrlasso->lpts);
	gfrlasso->l=gnome_canvas_item_new(GNOME_CANVAS_GROUP(canvas_group),gnome_canvas_line_get_type(),
					"points",gfrlasso->lpts,
					"fill_color_rgba",outline_rgba,
					"width_units",1.0,
					NULL);
	gfrlasso->tpts=gnome_canvas_points_new(2);
	gnome_canvas_points_ref(gfrlasso->tpts);
	gfrlasso->t=gnome_canvas_item_new(GNOME_CANVAS_GROUP(canvas_group),gnome_canvas_line_get_type(),
					"points",gfrlasso->tpts,
					"fill_color_rgba",outline_rgba,
					"width_units",1.0,
					NULL);
	gfrlasso->rpts=gnome_canvas_points_new(2);
	gnome_canvas_points_ref(gfrlasso->rpts);
	gfrlasso->r=gnome_canvas_item_new(GNOME_CANVAS_GROUP(canvas_group),gnome_canvas_line_get_type(),
					"points",gfrlasso->rpts,
					"fill_color_rgba",outline_rgba,
					"width_units",1.0,
					NULL);
	gfrlasso->bpts=gnome_canvas_points_new(2);
	gnome_canvas_points_ref(gfrlasso->bpts);
	gfrlasso->b=gnome_canvas_item_new(GNOME_CANVAS_GROUP(canvas_group),gnome_canvas_line_get_type(),
					"points",gfrlasso->bpts,
					"fill_color_rgba",outline_rgba,
					"width_units",1.0,
					NULL);
	gfilerunner_lasso_moveto(gfrlasso,x1,y1,x2,y2);
	return(gfrlasso);
}

void gfilerunner_lasso_moveto(gfilerunner_lasso* gfrlasso,gfloat x1,gfloat y1,gfloat x2,gfloat y2){
	if(gfrlasso){
//		if(gfrlasso->lasso){
		if((gfrlasso->lpts)&&(gfrlasso->tpts)&&(gfrlasso->rpts)&&(gfrlasso->bpts)&&
			(gfrlasso->l)&&(gfrlasso->t)&&(gfrlasso->r)&&(gfrlasso->b)){
			int tmp;
			gfrlasso->x1=x1;
			gfrlasso->y1=y1;
			gfrlasso->x2=x2;
			gfrlasso->y2=y2;
			if(x2<x1){
				tmp=x1;
				x1=x2;
				x2=tmp;
			}
			if(y2<y1){
				tmp=y1;
				y1=y2;
				y2=tmp;
			}
			gfrlasso->fx1=x1;
			gfrlasso->fy1=y1;
			gfrlasso->fx2=x2;
			gfrlasso->fy2=y2;
			/*gnome_canvas_item_set(GNOME_CANVAS_ITEM(gfrlasso->lasso),
						"x1",x1,"y1",y1,
						"x2",x2,"y2",y2,
						NULL);
			*/
			gfrlasso->lpts->coords[0]=x1;
			gfrlasso->lpts->coords[1]=y1;
			gfrlasso->lpts->coords[2]=x1;
			gfrlasso->lpts->coords[3]=y2;
			gnome_canvas_item_set(GNOME_CANVAS_ITEM(gfrlasso->l),"points",gfrlasso->lpts,NULL);
			gfrlasso->tpts->coords[0]=x1;
			gfrlasso->tpts->coords[1]=y1;
			gfrlasso->tpts->coords[2]=x2;
			gfrlasso->tpts->coords[3]=y1;
			gnome_canvas_item_set(GNOME_CANVAS_ITEM(gfrlasso->t),"points",gfrlasso->tpts,NULL);
			gfrlasso->rpts->coords[0]=x2;
			gfrlasso->rpts->coords[1]=y1;
			gfrlasso->rpts->coords[2]=x2;
			gfrlasso->rpts->coords[3]=y2;
			gnome_canvas_item_set(GNOME_CANVAS_ITEM(gfrlasso->r),"points",gfrlasso->rpts,NULL);
			gfrlasso->bpts->coords[0]=x1;
			gfrlasso->bpts->coords[1]=y2;
			gfrlasso->bpts->coords[2]=x2;
			gfrlasso->bpts->coords[3]=y2;
			gnome_canvas_item_set(GNOME_CANVAS_ITEM(gfrlasso->b),"points",gfrlasso->bpts,NULL);
		}
	}
}

void gfilerunner_lasso_free(gfilerunner_lasso* gfrlasso){
        if(gfrlasso){
//                if(gfrlasso->lasso){
//			gtk_object_destroy(GTK_OBJECT(gfrlasso->lasso));
//			gfrlasso->lasso=NULL;
//                }
		if((gfrlasso->lpts)&&(gfrlasso->tpts)&&(gfrlasso->rpts)&&(gfrlasso->bpts)&&
			(gfrlasso->l)&&(gfrlasso->t)&&(gfrlasso->r)&&(gfrlasso->b)){
					
			gtk_object_destroy(GTK_OBJECT(gfrlasso->l));
			gtk_object_destroy(GTK_OBJECT(gfrlasso->t));
			gtk_object_destroy(GTK_OBJECT(gfrlasso->r));
			gtk_object_destroy(GTK_OBJECT(gfrlasso->b));
			gfrlasso->l=NULL;
			gfrlasso->t=NULL;
			gfrlasso->r=NULL;
			gfrlasso->b=NULL;
			gnome_canvas_points_unref(gfrlasso->lpts);
			gnome_canvas_points_unref(gfrlasso->tpts);
			gnome_canvas_points_unref(gfrlasso->rpts);
			gnome_canvas_points_unref(gfrlasso->bpts);
			gfrlasso->lpts=NULL;
			gfrlasso->tpts=NULL;
			gfrlasso->rpts=NULL;
			gfrlasso->bpts=NULL;
			g_free(gfrlasso);
	        }
	}
}
