/*
*  Header for most of the system related functions
*/

#ifndef GFILERUNNER_SYS_H
#define GFILERUNNER_SYS_H

#include <sys/types.h>
#include <unistd.h>
#include <stdio.h>
#include <glib.h>

gboolean ends_with_delim(const char*teststr,char delim);
int spawnvp(char**);
char* get_command_output(const char*command);

/*these were mainly to make the code nicer...*/
gboolean file_exists(const char*filename);
char*get_theme_ent(const char*theme,const char*filename);
gboolean get_str_bool(const char*str);
char*script_get_info_var(const char*script,const char*opt);
char**script_get_info_array(const char*script,const char*opt);
gboolean script_get_info_bool(const char*script,const char*opt);

#endif