#ifndef GFILERUNNER_VFSOBJECT_H
#define GFILERUNNER_VFSOBJECT_H

#include <libgnomevfs/gnome-vfs.h>
#include "gfilerunner-basic-icon-types.h"

typedef struct _gfilerunner_vfs_obj gfilerunner_vfs_obj;
struct _gfilerunner_vfs_obj{
	char*uri;
	GnomeVFSFileInfo*info;
	basic_icon*icon;
};

gfilerunner_vfs_obj* gfilerunner_vfs_obj_new(const char*uri,GnomeVFSFileInfo*info,basic_icon*icon);
gfilerunner_vfs_obj* gfilerunner_vfs_obj_dup(gfilerunner_vfs_obj*vfsobj);
void gfilerunner_vfs_obj_free(gfilerunner_vfs_obj*vfsobj);

#endif