//TODO:  Rename this file and rearrange some code...
//TODO:  Split gfilerunner_window into a gfilerunner_window that uses a gfilerunner_view...that way the desktop doesn't reinvent the wheel.
#ifndef INTERFACE_H
#define INTERFACE_H

#include <libgnomevfs/gnome-vfs.h>
#include <libgnomevfs/gnome-vfs-mime-handlers.h>
#include "gfilerunner-theme-defs.h"
#include "gfilerunner-basic-icon.h"
#include "gfilerunner-lasso.h"
#include "gfilerunner-tree.h"
#include "gfilerunner-clipboard.h"
#include "gfilerunner-preferences.h"
//TODO:  Move this code when module code is merged or possibly use define's and ifdef's
#include "gfilerunner-filemod.h"

//FIXME:  TODO:  TO BE IMPLIMENTED
//gfilerunner_window_update_theme
//gfilerunner_window
//TODO:  for prefs, it should be done like this:
//		keep a pointer in the gfilerunner_view struct that points to an allocated prefs struct
//	 	make functions for everything to have them reread the prefs struct and update accordingly....
//  that way when we change global prefs we can tell who to update what...seems logical to me......
//
gfilerunner_preferences*gfrprefs;

typedef struct _gfilerunner_window gfilerunner_window;
struct _gfilerunner_window{
	 GtkWidget*window;	 //Main GtkWindow
	 GtkWidget*location;  //location GtkEntry
	 char*clocation;	//current location URI
	 GnomeVFSURI*locationURI;  //current location as a GnomeVFSURI
	 GtkWidget *btnGo;
	 GtkWidget*scrolledwindowRHS;  //File area's scrolledwindow widget
	 GtkWidget*canvas;	//Main root canvas for drawing
	 GnomeCanvasGroup*canvas_group; //Canvas group to be nested withing the root canvas, this is our main drawing area
	 GtkWidget*appbar;  //our status bar

//TODO:  Toolbar cleanup
	 GtkWidget *btnBack;
	 GtkWidget *btnForward;
	 GtkWidget *btnUp;
	 GtkWidget *btnStop;
	 GtkWidget *btnRefresh;
	 GtkWidget *btnCut;
	 GtkWidget *btnCopy;
	 GtkWidget *btnPaste;
	 GtkWidget *btnTrash;
	 GtkWidget *btnUndo;
	 GtkWidget *btnSearch;
	 GtkWidget *btnHome;
//TODO:  Toolbar cleanup

//Multiple selection information....
	 gfilerunner_lasso*lasso;
	 
	 GnomeVFSAsyncHandle *asyncvfs_handle;   //Keep track of the current loader....so that it can be cancelled...
	 gint dequeue_handle;                //ID for the deque_handler...basically to undo it all.....gtk_idle_remove(gint tag);
	 gint animation_idle_handle;	    //ID for the animation idle handle
	 gint progress_handle;               //ID for the progress_handler....
	 gboolean is_scanning;
	 GList*file_queue;	//List of GnomeVFSFileInfo*s
//	 GList*file_icons; //list of basic_icon*s
	 basic_icon*animation_handle; //handle for the animation of icons

	 //PUT THIS IN A STATS OR TOTALS STRUCTURE
	 int files_read;                     //Files read (dequeued) in from GList (and drawn) so far...
	 int dirs_read;
	 int objects_read;
	 int total_files;                    //TODO:  this is getting rediculous
	 int total_dirs;
	 int total_objects;				//Absolute total.... total_files+total_dirs

	 gpointer last_item;
	 gpointer icon_selection;
	 
	 gfilerunner_tree*gfrtree;

	 gfilerunner_clipboard* selection;	 

	 GnomeCanvasRE*bghack;
};

gfilerunner_clipboard* gfrclipboard;

gfilerunner_window* gfilerunner_window_new(char*location);
void gfilerunner_window_set_location(gfilerunner_window*gfrwin,char*location);
void gfilerunner_window_set_location_uri(gfilerunner_window*gfrwin,GnomeVFSURI*location);
void gfilerunner_window_show_lasso(gfilerunner_window*gfrwin,gfloat x1,gfloat y1,gfloat x2,gfloat y2);
void gfilerunner_window_hide_lasso(gfilerunner_window*gfrwin);
void gfilerunner_window_clear_selection(gfilerunner_window*gfrwin);
void gfilerunner_window_refresh_selection(gfilerunner_window*gfrwin);
void gfilerunner_window_free(gfilerunner_window*gfrwin);

#endif
