#ifndef GFILERUNNER_BASIC_ICON_TYPES_H
#define GFILERUNNER_BASIC_ICON_TYPES_H

#include <gnome.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk-pixbuf/gnome-canvas-pixbuf.h>
#include <libgnomeui/gnome-canvas.h>
#include <librsvg/rsvg.h>  /*TODO: This should be a module!!*/

//TODO:  This should be an option maybe?  doubt it...but maybe...
#define GFR_ICON_WIDTH 64
#define GFR_ICON_HEIGHT 64
#define GFR_ICON_WIDTH2 (GFR_ICON_WIDTH>>1)
#define GFR_ICON_HEIGHT2 (GFR_ICON_HEIGHT>>1)

//TODO:  Option to turn this off....
//TODO:  Add 3D spin, FadeIn&Out
typedef enum{ ANI_BOUNCE=0,ANI_ROTATE,ANI_PULSATE } basic_icon_AnimationMode;
typedef enum{ GFR_ICON_DEC_NONE=0,	/* TODO: FINISH THESE */
							GFR_ICON_DEC_SYMLINK,
							GFR_ICON_DEC_BROKEN_SYMLINK,
							GFR_ICON_DEC_ACCESS_DENIED} basic_icon_Decoration;

typedef struct _basic_icon basic_icon;
struct _basic_icon{
	GnomeCanvasGroup* parent;
	GnomeCanvasGroup* icon_group;
	GnomeCanvasPixbuf* pixbuf;
	GdkPixbuf *_pixbuf;
	GnomeCanvasPixbuf*link;
	GdkPixbuf* _link;
	GnomeCanvasText* caption;
	GnomeCanvasRE* highlight;

	GnomeCanvasPixbuf*preview;
	GdkPixbuf*_preview_pixbuf;

	double x1, y1, x2, y2;
	basic_icon_AnimationMode effect_type;
	basic_icon_Decoration decoration;
	double effect_data[2];  //Array for keeping special-effect specific data on each individual icon
	double angle;  //FIXME:  NUKE this...switch to the above...start not clearing the icons until the first
	double scale;  //  icon is ready to be drawn...ie..to give us time and a reason for our spiffy effects...
	int visible : 1;
	int stretched : 1;
	int highlighted : 1;
	int previewing : 1;
};

#endif
