
//This is our "lasso" (multiple file selection w/ mouse)
//
#ifndef GFILERUNNER_LASSO_H
#define GFILERUNNER_LASSO_H

#include "gfilerunner-basic-icon-types.h" //Mainly get the same includes as basic-icon does...

typedef struct _gfilerunner_lasso gfilerunner_lasso;
struct _gfilerunner_lasso{
	gfloat x1;	//These are the un-"fixed" coordinates
	gfloat y1;
	gfloat x2;
	gfloat y2;
	gfloat fx1;	//These are the "fixed" coordinates (ie if fx1>fx2 then swap(fx1,fx2) etc..)  fx1 is always less than fx2, etc.
	gfloat fy1;
	gfloat fx2;
	gfloat fy2;
//	GnomeCanvasRE*lasso;
	GnomeCanvasPoints*lpts;
	GnomeCanvasLine*l;
	GnomeCanvasPoints*tpts;
	GnomeCanvasLine*t;
	GnomeCanvasPoints*rpts;
	GnomeCanvasLine*r;
	GnomeCanvasPoints*bpts;
	GnomeCanvasLine*b;
//TODO:  ideas for the future.....
//	GnomeCanvasPixbuf*handle_pixbuf;
};

gfilerunner_lasso* gfilerunner_lasso_new(GnomeCanvasGroup*canvas_group,gfloat x1,gfloat y1,gfloat x2,gfloat y2,
						long fill_rgba,GdkBitmap*fill_stipple,long outline_rgba);
void gfilerunner_lasso_moveto(gfilerunner_lasso* gfrlasso,gfloat x1,gfloat y1,gfloat x2,gfloat y2);
void gfilerunner_lasso_free(gfilerunner_lasso* gfrlasso);


#endif
