#ifndef GFILERUNNER_SCRIPT_H
#define GFILERUNNER_SCRIPT_H

#include <glib.h>

#define GFILERUNNER_SCRIPT_GET_INFO "--get-info"
#define GFILERUNNER_SCRIPT_FLAG_EXECUTE	"--execute"

typedef struct _gfilerunner_script gfilerunner_script;
struct _gfilerunner_script{
	char*file; /* full path to our actual script */
	char*name;
	char*version;
	char**authors;
	char*about;  /* this can be multilined, but we don't need to break it into a vector... */
	char**mime_types;
	gboolean needs_terminal;
	gboolean multiple_files;
	gboolean local_only;
};

gfilerunner_script*gfilerunner_script_new(const char*script);
gfilerunner_script*gfilerunner_script_dup(gfilerunner_script*oldgfrscript);
void gfilerunner_script_free(gfilerunner_script*gfrscript);

#endif