// gfilerunner-tree-object.h  -   by Kyle Davis
//
// This should allow GFileRunner's tree handler to have objects.
//
#ifndef GFILERUNNER_TREE_OBJECT_H
#define GFILERUNNER_TREE_OBJECT_H

#include "gfilerunner-basic-icon.h"

typedef struct _gfilerunner_tree_object gfilerunner_tree_object;
struct _gfilerunner_tree_object{
        char*location;		//Text for tree widget
        char*desc;		//For later...tooltip maybe
	void*data;		//we WILL use this
	GdkPixmap*collapse_pixmap;
	GdkBitmap*collapse_mask;
        GdkPixmap*expand_pixmap;
        GdkBitmap*expand_mask;
};

//New gfilerunner_tree_object  ( location, description, expand icon filename, collapse icon filename )
gfilerunner_tree_object* gfilerunner_tree_object_new(const char*location,const char*desc,const char*collapse_pixbuf_file,const char*expand_pixbuf_file);

//Same as above, but for when we have objects using the same pic...(probably a lot!)
gfilerunner_tree_object* gfilerunner_tree_object_new_noload(const char*location,const char*desc,GdkPixmap*cp,GdkBitmap*cb,GdkPixmap*ep,GdkBitmap*eb);
	

//Free gfiletunner_tree_object
void gfilerunner_tree_object_free(gfilerunner_tree_object* gfrtree_object);

#endif
