
#include "gfilerunner-vfs-object.h"

gfilerunner_vfs_obj* gfilerunner_vfs_obj_new(const char*uri,GnomeVFSFileInfo*info,basic_icon*icon){
	gfilerunner_vfs_obj*vfsobj=g_new(gfilerunner_vfs_obj,1);
	g_assert(vfsobj!=NULL);
	vfsobj->uri=g_strdup(uri);
	vfsobj->info=info;
	vfsobj->icon=icon;
	return(vfsobj);
}

gfilerunner_vfs_obj* gfilerunner_vfs_obj_dup(gfilerunner_vfs_obj*vfsobj){
	gfilerunner_vfs_obj*nvfsobj=g_new(gfilerunner_vfs_obj,1);
	nvfsobj->uri=g_strdup(vfsobj->uri);
	nvfsobj->info=gnome_vfs_file_info_dup(vfsobj->info);
	nvfsobj->icon=basic_icon_dup(vfsobj->icon);
	return(nvfsobj);
}

void gfilerunner_vfs_obj_free(gfilerunner_vfs_obj*vfsobj){
	if(vfsobj){
		if(vfsobj->uri) g_free(vfsobj->uri);
		g_free(vfsobj);
	}
}
