struct _gfilerunner_window{
  GtkWidget *gfilerunner;

  GtkWidget *dock;
  GtkWidget *toolbar;
  GtkWidget *btnBack;
  GtkWidget *btnForward;
  GtkWidget *btnUp;
  GtkWidget *btnStop;
  GtkWidget *btnRefresh;
  GtkWidget *btnCut;
  GtkWidget *btnCopy;
  GtkWidget *btnPaste;
  GtkWidget *btnTrash;
  GtkWidget *btnUndo;
  GtkWidget *btnHome;
		      
  GtkWidget *lblLocation;
  GtkWidget *entryLocation;
  GtkWidget *btnGo;

  GtkWidget *lblZoom;
  GtkObject *spinbtnZoom_adj;
  GtkWidget *spinbtnZoom;

  GtkWidget *optmenuView;
  GtkWidget *optmenuView_menu;

  GtkWidget *appbar1;                 //Easy access to our status bar and progress bar

  GtkWidget *hpane;
  GtkWidget *scrolledwindowLHS;
  GtkWidget *scrolledwindowRHS;
  GtkWidget *viewportLHS;

  GtkWidget *ctree;
  GtkCTreeNode*root_fs_node;

  GtkWidget*gfr_canvas;			//The root_canvas_group....mainly for creating this next one
  GnomeCanvasGroup*gfr_canvas_group;	//keep all the objects on a dummy group that way we don't pollute the root_canvas_group

  gboolean gfr_canvas_aa;		//Whether or not to use AA on our canvas items

  GList*file_queue;			//List of GnomeVFSFileInfo Pointers
  GList*file_icons;			//this will hold basic_file ptrs

  basic_icon* animation_handle;		//ID for the animation_handler...
  GnomeVFSAsyncHandle *asyncvfs_handle;	//Keep track of the current loader....so that it can be cancelled...
  gint dequeue_handle;			//ID for the deque_handler...basically to undo it all.....gtk_idle_remove(gint tag);
  gint progress_handle;			//ID for the progress_handler....
  gboolean scanning_handle;		//Are we scanning the directory still?
  int files_read;			//Files read (dequeued) in from GList (and drawn) so far...
  int dirs_read;			//Direcotories read (dequeued) in from GList (and drawn) so far...
  int total_files;			//TODO:  this is getting rediculous
  int total_dirs;			//TODO:  fix this
  int total_objects;			//Absolute total.... total_files+total_dirs

  gpointer last_item;			//Last item with an event
  gpointer icon_selection;		//Icon Selection
};

GList*common_pixbufs;                   //I can cache all the standard icons here....as to play nice with remote ppl.
  
GdkPixmap*folder_closed_pixmap;
GdkBitmap*folder_closed_mask;
GdkPixmap*folder_open_pixmap;
GdkBitmap*folder_open_mask;
